<?php

/**
 * @file
 * Contains string manipulator class.
 */

/**
 * String manipulator class.
 */
class DCStringManipulator {

  // Stored string value.
  protected $string;

  // Last String value.
  protected $stringLast;

  // Last operation results.
  protected $results;

  /**
   * Constructor.
   */
  public function __construct($string = '') {
    $this->string = $string;
  }

  /**
   * Get current string value.
   */
  public function getString() {
    return $this->string;
  }

  /**
   * Get last string value.
   */
  public function getLast() {
    if (isset($this->stringLast)) {
      return $this->stringLast;
    }
    else {
      return FALSE;
    }
  }

  /**
   * Get results of the last operation.
   */
  public function getResults() {
    if (isset($this->results)) {
      return $this->results;
    }
    else {
      return FALSE;
    }
  }

  // Methods -----------------------.

  /**
   * Get all objects in a string.
   *
   * @param string $start_str
   *   The beginning string of the object.
   * @param string $unique_str
   *   An unique portion of an object to search for.
   * @param string $end_str
   *   The ending string of the object.
   * @param string, bool $replacement
   *   Replacement string for found objects in source string.
   *   If FALSE no replacement will be made.
   */
  public function getObjects($start_str, $unique_str, $end_str, $replacement = FALSE) {
    $this->stringLast = $this->string;
    $this->results = array();

    $start_offset = 0;
    while ($pos = strpos($this->string, $unique_str, $start_offset)) {
      $dummy = substr($this->string, 0, $pos);
      $start = strrpos($dummy, $start_str, 0);
      $end = strpos($this->string, $end_str, $pos);
      if ($start !== FALSE && $end !== FALSE) {
        $end += strlen($end_str);
        $length = $end - $start;
        $this->results[] = substr($this->string, $start, $length);
        if ($replacement !== FALSE && is_string($replacement)) {
          $start_offset += strlen($replacement);
          $this->string = substr_replace($this->string, $replacement, $start, $length);
        }
        else {
          $start_offset = $end;
        }
      }
      else {
        break;
      }
    }
  }

}
