<?php

/**
 * @file
 * Contains module settings form.
 */

/**
 * Settings form definition.
 */
function developer_console_settings_form($form, &$form_state) {
  $check_ips = variable_get('developer_console_check_ips', array());
  $form['check_ips'] = array(
    '#type' => 'textarea',
    '#rows' => 3,
    '#resizable' => FALSE,
    '#default_value' => implode(', ', $check_ips),
    '#description' => t('IP addresses that have request monitoring enabled. Leave empty to disable request monitoring completely. Your IP: @ip', array('@ip' => ip_address()))
  );

  $form['save'] = array(
    '#type' => 'submit',
    '#value' => t('Save settings')
  );

  return $form;
}

/**
 * Submit handler.
 */
function developer_console_settings_form_submit($form, &$form_state) {
  if (!empty($form_state['values']['check_ips'])) {
    $ips = explode(',', $form_state['values']['check_ips']);
    foreach ($ips as $index => $ip) {
      $ips[$index] = trim($ip);
    }
    variable_set('developer_console_check_ips', $ips);
  }
  else {
    variable_del('developer_console_check_ips');
  }
}
